/**********
This library is free software; you can redistribute it and/or modify it under
the terms of the GNU Lesser General Public License as published by the
Free Software Foundation; either version 2.1 of the License, or (at your
option) any later version. (See <http://www.gnu.org/copyleft/lesser.html>.)

This library is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
more details.

You should have received a copy of the GNU Lesser General Public License
along with this library; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**********/
// "liveMedia"
// Copyright (c) 1996-2001 Live Networks, Inc.  All rights reserved.
// Bit Vector data structure
// C++ header

#ifndef _BIT_VECTOR_HH
#define _BIT_VECTOR_HH 1

class BitVector {
public:
  BitVector(unsigned char* baseBytePtr,
	    unsigned int baseBitOffset,
	    unsigned int totNumBits);

  void setup(unsigned char* baseBytePtr,
	     unsigned int baseBitOffset,
	     unsigned int totNumBits);

  void putBits(unsigned int from, unsigned int numBits); // "numBits" <= 32
  void put1Bit(unsigned int bit);

  unsigned int getBits(unsigned int numBits); // "numBits" <= 32
  unsigned int get1Bit();

  void skipBits(unsigned int numBits);

  unsigned int curBitIndex() const { return fCurBitIndex; };
  unsigned int totNumBits() const { return fTotNumBits; };

private:
  unsigned char* fBaseBytePtr;
  unsigned int fBaseBitOffset;
  unsigned int fTotNumBits;
  unsigned int fCurBitIndex;
};

// A general bit copy operation:
void shiftBits(unsigned char* toBasePtr, unsigned int toBitOffset,
	       unsigned char const* fromBasePtr, unsigned int fromBitOffset,
	       unsigned int numBits);

#endif
